#include "Razlomak.h"

#include <iostream>

Razlomak::Razlomak(int brojilac, unsigned int imenilac)
    : m_brojilac(brojilac), m_imenilac(imenilac)
{
}   

int Razlomak::brojilac() const
{
    return m_brojilac;
}   

void Razlomak::postaviBrojilac(int brojilac)
{
    m_brojilac = brojilac;
}   

unsigned int Razlomak::imenilac() const
{
    return m_imenilac;
}   
    
void Razlomak::postaviImenilac(unsigned int imenilac)
{           
    m_imenilac = imenilac;
}   
    
Razlomak Razlomak::operator + (const Razlomak & other) const
{
    // Mozemo da koristimo getere ili direktno da pristupamo clanovima klase
    return Razlomak(
            imenilac() * other.brojilac() + other.imenilac() * brojilac(),
            imenilac() * other.imenilac()
        ); 
}   
    
Razlomak Razlomak::operator ++ (int)
{   
    // Ovde direktno pristupamo clanovima klase
    m_brojilac+= m_imenilac;

    return Razlomak(m_brojilac - m_imenilac, m_imenilac);
}

Razlomak & Razlomak::operator ++ ()
{   
    // Uvecavamo razlomak za 1
    m_brojilac += m_imenilac;

    return (*this);
}

std::istream & operator >> (std::istream & in, Razlomak & value)
{
    char c; // pri citanju zelimo da preskocimo razlomacku crtu
    int brojilac;
    unsigned int imenilac;
    in >> brojilac >> c >> imenilac;

    value.postaviBrojilac(brojilac);
    value.postaviImenilac(imenilac);

    return in;

}

std::ostream & operator << (std::ostream & out, const Razlomak & value)
{
    return out << value.brojilac() << '/' << value.imenilac();
}



