#include "razlomak.h"

#include <QtMath>
#include <QString>
#include <QStringList>


Razlomak::Razlomak(int b, int i )
    : brojilac(b),
      imenilac(i){
PopraviPodatke();
}


int Razlomak::Brojilac() const
    { return brojilac; }

int Razlomak::Imenilac() const
    { return imenilac; }

void Razlomak::PostaviRazlomak( int b, int i )
        {
         brojilac = b;
         imenilac = i;
        PopraviPodatke();
        }

// definisanje aritmetickih operatora
Razlomak Razlomak::operator + ( const Razlomak& y ) const
        {
        return Razlomak(
            Brojilac() * y.Imenilac()
                + Imenilac() * y.Brojilac(),
            Imenilac() * y.Imenilac()
            );
        }
Razlomak Razlomak::operator - ( const Razlomak& y ) const
        {
        return Razlomak(
            Brojilac() * y.Imenilac()
                - Imenilac() * y.Brojilac(),
            Imenilac() * y.Imenilac()
            );
        }


Razlomak Razlomak::operator - () const
        {
        return Razlomak(
            -Brojilac(),
            Imenilac()
            );
        }

Razlomak Razlomak::operator ~ () const
        {
        return Razlomak(
            Imenilac(),
            Brojilac()
            );
        }


Razlomak& Razlomak::operator++ ()
        {
         brojilac += imenilac;
        return *this;
        }


Razlomak Razlomak::operator++ (int)
        {
        Razlomak r = *this;
         brojilac +=  imenilac;
        return r;
        }

// definisanje operatora poredjenja
bool Razlomak::operator==( const Razlomak& x ) const
        {
        return Brojilac() == x.Brojilac()
                && Imenilac() == x.Imenilac();
        }

bool Razlomak::operator!=( const Razlomak& x ) const
        { return !( *this == x ); }

Razlomak::operator double() const
        { return  brojilac / (double) imenilac; }


Razlomak::operator QString() const
        {
    return QString("%1/%2").arg( brojilac).arg( imenilac);
        }

void Razlomak::Citaj( QString s)
        {
        QStringList bii = s.split("/");

         brojilac=bii[0].toInt();

        if(bii.count()==1)
             imenilac=1;
        else
             imenilac=bii[1].toInt();

        PopraviPodatke();

        }

void Razlomak::PopraviPodatke()
{
    if(  imenilac < 0 ){
         brojilac = - brojilac;
         imenilac = - imenilac;
        }
    int n = nzd( qAbs( brojilac),  imenilac );
    if( n>1 ){
         brojilac /= n;
         imenilac /= n;
        }
}

int Razlomak::nzd( int a, int b )
{
    int t;
    if( a<b ){
        t = a;
        a = b;
        b = t;
        }
    while( b>0 ){
        t = b;
        b = a % b;
        a = t;
        }
    return a;
}

