#include "razlomakqt.h"

//#include <QRegExp>
#include <qmessagebox.h>


RazlomakQt::RazlomakQt(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::RazlomakQt)
{
    ui->setupUi(this);
    ui->lineEditRazlomak->setReadOnly(true);
    izraz="";
    ui->textEditIzraz->setReadOnly(true);

    mapper.setMapping( ui->pushButton0, "0" );
    mapper.setMapping( ui->pushButton1, "1" );
    mapper.setMapping( ui->pushButton2, "2" );
    mapper.setMapping( ui->pushButton3, "3" );
    mapper.setMapping( ui->pushButton4, "4" );
    mapper.setMapping( ui->pushButton5, "5" );
    mapper.setMapping( ui->pushButton6, "6" );
    mapper.setMapping( ui->pushButton7, "7" );
    mapper.setMapping( ui->pushButton8, "8" );
    mapper.setMapping( ui->pushButton9, "9" );
    mapper.setMapping( ui->pushButtonCrta, "/" );

    // povezuju se signali i slotovi(metode koje se izvrsavaju kada se emituje odredjeni signal)
    connect( ui->pushButton0, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton1, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton2, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton3, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton4, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton5, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton6, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton7, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton8, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButton9, SIGNAL(clicked()), &mapper, SLOT(map()) );
    connect( ui->pushButtonCrta, SIGNAL(clicked()), &mapper, SLOT(map()) );

    connect( &mapper, SIGNAL(mapped(QString)), this, SLOT(unosCifreIliCrte(QString)) );

}

RazlomakQt::~RazlomakQt()
{
    delete ui;
}


void RazlomakQt::izracunaj()
{
    trenutniRazlomak.Citaj(ui->lineEditRazlomak->text());

    if(izraz.compare("")==0)
    {
        izraz=(QString)trenutniRazlomak;
    }

    if(ui->textEditIzraz->toPlainText().compare("")==0)
    {
        ui->textEditIzraz->setText(izraz);
        rezultat=trenutniRazlomak;
    }

    if(binarni=='+')
    {
        rezultat=rezultat + trenutniRazlomak;
        ui->textEditIzraz->setText(ui->textEditIzraz->toPlainText() + "+" + izraz);
    }
    else if (binarni== '-')
    {
        rezultat=rezultat-trenutniRazlomak;
        ui->textEditIzraz->setText(ui->textEditIzraz->toPlainText() + "-" + izraz);
    }

    izraz="";
    ui->lineEditRazlomak->clear();
    ui->labelResenje->setText(rezultat);
}

void RazlomakQt::unosCifreIliCrte(QString unos)
{
    ui->lineEditRazlomak->setText(ui->lineEditRazlomak->text()+ unos);
    izraz+=unos;
}

void RazlomakQt::minus()
{
    trenutniRazlomak.Citaj(ui->lineEditRazlomak->text());

    if(izraz.compare("")==0)
        izraz=(QString)trenutniRazlomak;

    ui->lineEditRazlomak->setText(-trenutniRazlomak);


    izraz="(-" + izraz +")";

}

void RazlomakQt::inverz()
{
    trenutniRazlomak.Citaj(ui->lineEditRazlomak->text());

    if(izraz.compare("")==0)
        izraz=QString(trenutniRazlomak);


    ui->lineEditRazlomak->setText(~trenutniRazlomak);


    izraz="(~" + izraz +")";
}

void RazlomakQt::prefiksnoPlusPlus()
{
    trenutniRazlomak.Citaj(ui->lineEditRazlomak->text());

    if(izraz.compare("")==0)
        izraz=(QString)trenutniRazlomak;

    ui->lineEditRazlomak->setText(++trenutniRazlomak);


    izraz="(++" + izraz +")";

}

void RazlomakQt::sabiranje()
{
    if(ui->lineEditRazlomak->text().compare("")==0)
        QMessageBox::information(this, "Neophodan unos", "Unesite razlomak");
    else
    {
        izracunaj();
        binarni='+';
    }
}

void RazlomakQt::oduzimanje()
{
    if(ui->lineEditRazlomak->text().compare("")==0)
        QMessageBox::information(this, "Neophodan unos", "Unesite razlomak");
    else
    {
        izracunaj();
        binarni='-';
    }
}

void RazlomakQt::jednako()
{
    izracunaj();
    ui->textEditIzraz->setText(ui->textEditIzraz->toPlainText() + "=" + (QString)rezultat);
    zakljucaj();
}

void RazlomakQt::zakljucaj()
{
    ui->pushButton0->setEnabled(false);
    ui->pushButton1->setEnabled(false);
    ui->pushButton2->setEnabled(false);
    ui->pushButton3->setEnabled(false);
    ui->pushButton4->setEnabled(false);
    ui->pushButton5->setEnabled(false);
    ui->pushButton6->setEnabled(false);
    ui->pushButton7->setEnabled(false);
    ui->pushButton8->setEnabled(false);
    ui->pushButton9->setEnabled(false);
    ui->pushButtonCrta->setEnabled(false);
    ui->pushButtonJednako->setEnabled(false);
    ui->pushButtonUMinus->setEnabled(false);
    ui->pushButtonInverz->setEnabled(false);
    ui->pushButtonPlus->setEnabled(false);
    ui->pushButtonMinus->setEnabled(false);
    ui->pushButtonPlusPlus->setEnabled(false);
    ui->lineEditRazlomak->setEnabled(false);

}

